//------------------------------------------------------------------
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//------------------------------------------------------------------
#property  indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrSilver
#property indicator_color2  clrLimeGreen
#property indicator_color3  clrLimeGreen
#property indicator_width1  2
#property indicator_width2  4
#property indicator_width3  4
#property strict

extern int     EMAPeriod    = 9;    // EMA period
extern int     SecondPeriod = 9;    // Second EMA period
extern int     SumPeriod    = 25;   // Sum period
extern double  Level1       = 26.5; // Lower level
extern double  Level2       = 27.0; // Higher level

double mi[],mira[],mirb[],state[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,mi);
   SetIndexBuffer(1,mira);
   SetIndexBuffer(2,mirb);
   SetIndexBuffer(3,state);
      SetLevelValue(0,Level1);
      SetLevelValue(1,Level2);
   IndicatorShortName("Mass Index(" + (string)EMAPeriod + "," + (string)SecondPeriod + "," + (string)SumPeriod + ")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   if (state[limit]==1) CleanPoint(limit,mira,mirb);
   for(int i=limit; i>=0; i--)
   {
       double HL        = High[i] - Low[i];
       double HLaverage = iEma(HL,EMAPeriod,i,0);
       double EMA2      = HLaverage / iEma(HLaverage, SecondPeriod, i, 1);
              mi[i]     = iSma(EMA2,SumPeriod,i)*SumPeriod;
              mira[i]   = EMPTY_VALUE;
              mirb[i]   = EMPTY_VALUE;
              state[i]  = (mi[i]>Level2) ? 1 : (mi[i]<Level1) ? -1 : (i<Bars-1) ? state[i+1] : 0;
              if (state[i]==1) PlotPoint(i,mira,mirb,mi);
   }
   return(0);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _smaInstances 2
double workSma[][_smaInstances];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r=Bars-r-1; int k;

   workSma[r][instanceNo+0] = price;
   workSma[r][instanceNo+1] = price; for(k=1; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo+0];  
   workSma[r][instanceNo+1] /= 1.0*k;
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

#define _emaInstances 2
double workEma[][_emaInstances];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}